if not table.pack then table.pack = function(...) return { n = select("#", ...), ... } end end
if not table.unpack then table.unpack = unpack end
local load = load if _VERSION:find("5.1") then load = function(x, n, _, env) local f, e = loadstring(x, n) if not f then return f, e end if env then setfenv(f, env) end return f end end
local _select, _unpack, _pack, _error = select, table.unpack, table.pack, error
local _libs = {}
local _2a_arguments_2a_1, _2b_1, _2d3e_ratComponents1, _2d_1, _2e2e_1, _2f3d_1, _2f_1, _3c3d_1, _3c_1, _3d_1, _3e3d_1, _3e_1, _enot1, abs1, append1, appendAll_21_1, apply1, arg_23_1, cadddr1, caddr1, cadr1, car1, car2, ceil1, charAt1, close1, concat1, concat2, const1, constVal1, demandFailure1, demandFailure_2d3e_string1, denominator1, empty_3f_1, endsWith_3f_1, eq_3f_1, error1, execute1, exit1, exit_21_1, fail_21_1, fileExists_3f_1, flush1, format1, getIdx1, groupsOf1, gsub1, insertNth_21_1, last1, len_23_1, list1, match1, mod1, n1, neq_3f_1, next1, normalisedRationalComponents1, nth1, number_3f_1, numerator1, open1, pcall1, popLast_21_1, pred1, print1, printf1, push_21_1, put_21_1, read1, readAllMode_21_1, readLines_21_1, remove2, removeNth_21_1, reverse1, scroll1, self1, setIdx_21_1, setmetatable1, slice1, snoc1, splice1, split1, sprintf1, startsWith_3f_1, string_2d3e_chars1, string_3f_1, sub1, succ1, tmpname1, tonumber1, tostring1, traceback1, trim1, type1, type_23_1, unpack1, write1, writeAllMode_21_1, writeAll_21_1, writeLines_21_1
local _ENV = setmetatable({}, {__index=_ENV or (getfenv and getfenv()) or _G}) if setfenv then setfenv(0, _ENV) end
_3d_1 = function(v1, v2) return v1 == v2 end
_2f3d_1 = function(v1, v2) return v1 ~= v2 end
_3c_1 = function(v1, v2) return v1 < v2 end
_3c3d_1 = function(v1, v2) return v1 <= v2 end
_3e_1 = function(v1, v2) return v1 > v2 end
_3e3d_1 = function(v1, v2) return v1 >= v2 end
_2b_1 = function(x, ...) local t = x + ... for i = 2, _select('#', ...) do t = t + _select(i, ...) end return t end
_2d_1 = function(x, ...) local t = x - ... for i = 2, _select('#', ...) do t = t - _select(i, ...) end return t end
_2a_1 = function(x, ...) local t = x * ... for i = 2, _select('#', ...) do t = t * _select(i, ...) end return t end
_2f_1 = function(x, ...) local t = x / ... for i = 2, _select('#', ...) do t = t / _select(i, ...) end return t end
mod1 = function(x, ...) local t = x % ... for i = 2, _select('#', ...) do t = t % _select(i, ...) end return t end
expt1 = function(x, ...) local n = _select('#', ...) local t = _select(n, ...) for i = n - 1, 1, -1 do t = _select(i, ...) ^ t end return x ^ t end
_2e2e_1 = function(x, ...) local n = _select('#', ...) local t = _select(n, ...) for i = n - 1, 1, -1 do t = _select(i, ...) .. t end return x .. t end
len_23_1 = function(v1) return #v1 end
getIdx1 = function(v1, v2) return v1[v2] end
setIdx_21_1 = function(v1, v2, v3) v1[v2] = v3 end
arg_23_1 = arg or {...}
error1 = error
next1 = next
pcall1 = pcall
print1 = print
setmetatable1 = setmetatable
tonumber1 = tonumber
tostring1 = tostring
type_23_1 = type
find1 = string.find
format1 = string.format
gsub1 = string.gsub
len1 = string.len
match1 = string.match
rep1 = string.rep
sub1 = string.sub
concat1 = table.concat
insert1 = table.insert
remove1 = table.remove
unpack1 = table.unpack
n1 = function(x)
  if type_23_1(x) == "table" then
    return x["n"]
  else
    return #x
  end
end
slice1 = function(xs, start, finish)
  if not finish then
    finish = xs["n"]
    if not finish then
      finish = #xs
    end
  end
  local len, _ = (finish - start) + 1
  if len < 0 then
    len = 0
  end
  local out, i, j = {tag="list", n=len}, 1, start
  while j <= finish do
    out[i] = xs[j]
    i, j = i + 1, j + 1
  end
  return out
end
car1 = function(xs)
  return xs[1]
end
list1 = function(...)
  local xs = _pack(...) xs.tag = "list"
  return xs
end
_enot1 = function(expr)
  return not expr
end
if nil == arg_23_1 then
  _2a_arguments_2a_1 = {tag="list", n=0}
else
  arg_23_1["tag"] = "list"
  if not arg_23_1["n"] then
    arg_23_1["n"] = #arg_23_1
  end
  _2a_arguments_2a_1 = arg_23_1
end
constVal1 = function(val)
  if type_23_1(val) == "table" then
    local tag = val["tag"]
    if tag == "number" then
      return val["value"]
    elseif tag == "string" then
      return val["value"]
    else
      return val
    end
  else
    return val
  end
end
splice1 = function(xs)
  local parent = xs["parent"]
  if parent then
    return unpack1(parent, xs["offset"] + 1, xs["n"] + xs["offset"])
  else
    return unpack1(xs, 1, xs["n"])
  end
end
apply1 = function(f, ...)
  local _n = _select("#", ...) - 1
  local xss, xs
  if _n > 0 then
    xss = {tag="list", n=_n, _unpack(_pack(...), 1, _n)}
    xs = select(_n + 1, ...)
  else
    xss = {tag="list", n=0}
    xs = ...
  end
  return f(splice1((function()
    local _offset, _result, _temp = 0, {tag="list"}
    _temp = xss
    for _c = 1, _temp.n do _result[0 + _c + _offset] = _temp[_c] end
    _offset = _offset + _temp.n
    _temp = xs
    for _c = 1, _temp.n do _result[0 + _c + _offset] = _temp[_c] end
    _offset = _offset + _temp.n
    _result.n = _offset + 0
    return _result
  end)()
  ))
end
empty_3f_1 = function(x)
  local xt = type1(x)
  if xt == "list" then
    return x["n"] == 0
  elseif xt == "string" then
    return #x == 0
  else
    return false
  end
end
string_3f_1 = function(x)
  return type_23_1(x) == "string" or type_23_1(x) == "table" and x["tag"] == "string"
end
number_3f_1 = function(x)
  return type_23_1(x) == "number" or type_23_1(x) == "table" and x["tag"] == "number"
end
type1 = function(val)
  local ty = type_23_1(val)
  if ty == "table" then
    return val["tag"] or "table"
  else
    return ty
  end
end
put_21_1 = function(t, typs, l)
  local len = n1(typs)
  local forLimit = len - 1
  local i = 1
  while i <= forLimit do
    local x = typs[i]
    local y = t[x]
    if not y then
      y = {}
      t[x] = y
    end
    t = y
    i = i + 1
  end
  t[typs[len]] = l
  return nil
end
neq_3f_1 = function(x, y)
  return _enot1(eq_3f_1(x, y))
end
local eq_3f_
local this = {lookup={list={list=function(x, y)
  if n1(x) ~= n1(y) then
    return false
  else
    local equal = true
    local forLimit = n1(x)
    local i = 1
    while i <= forLimit do
      if neq_3f_1(x[i], y[i]) then
        equal = false
      end
      i = i + 1
    end
    return equal
  end
end}, table={table=function(x, y)
  local equal = true
  local temp, v = next1(x)
  while temp ~= nil do
    if neq_3f_1(v, y[temp]) then
      equal = false
    end
    temp, v = next1(x, temp)
  end
  return equal
end}, symbol={symbol=function(x, y)
  return x["contents"] == y["contents"]
end, string=function(x, y)
  return x["contents"] == y
end}, string={symbol=function(x, y)
  return x == y["contents"]
end, key=function(x, y)
  return x == y["value"]
end, string=function(x, y)
  return constVal1(x) == constVal1(y)
end}, key={string=function(x, y)
  return x["value"] == y
end, key=function(x, y)
  return x["value"] == y["value"]
end}, number={number=function(x, y)
  return constVal1(x) == constVal1(y)
end}, rational={rational=function(x, y)
  local xn, xd = normalisedRationalComponents1(x)
  local yn, yd = normalisedRationalComponents1(y)
  return xn == yn and xd == yd
end}}, tag="multimethod", default=function(x, y)
  return false
end}
eq_3f_ = setmetatable1(this, {__call=function(this1, x, y)
  if x == y then
    return true
  else
    local method = (this["lookup"][type1(x)] or {})[type1(y)] or this["default"]
    if not method then
      error1("No matching method to call for (" .. concat1(list1("eq?", type1(x), type1(y)), " ") .. ")")
    end
    return method(x, y)
  end
end, name="eq?", args=list1("x", "y")})
put_21_1(eq_3f_, list1("lookup", "number", "rational"), (eq_3f_["lookup"]["rational"] or {})["rational"])
put_21_1(eq_3f_, list1("lookup", "rational", "number"), (eq_3f_["lookup"]["rational"] or {})["rational"])
eq_3f_1 = eq_3f_
traceback1 = debug and debug.traceback
demandFailure_2d3e_string1 = function(failure)
  if failure["message"] then
    return format1("demand not met: %s (%s).\n%s", failure["condition"], failure["message"], failure["traceback"])
  else
    return format1("demand not met: %s.\n%s", failure["condition"], failure["traceback"])
  end
end
_2a_demandFailureMt_2a_1 = {__tostring=demandFailure_2d3e_string1}
demandFailure1 = function(message, condition)
  return setmetatable1({tag="demand-failure", message=message, traceback=(function()
    if traceback1 then
      return traceback1("", 2)
    else
      return ""
    end
  end)(), condition=condition}, _2a_demandFailureMt_2a_1)
end
abs1 = math.abs
ceil1 = math.ceil
modf1 = math.modf
car2 = function(x)
  if not (type1(x) == "list") then
    error1(demandFailure1(nil, "(= (type x) \"list\")"))
  end
  return car1(x)
end
drop1 = function(xs, n)
  return slice1(xs, n + 1, nil)
end
snoc1 = function(xss, ...)
  local xs = _pack(...) xs.tag = "list"
  local _offset, _result, _temp = 0, {tag="list"}
  _temp = xss
  for _c = 1, _temp.n do _result[0 + _c + _offset] = _temp[_c] end
  _offset = _offset + _temp.n
  _temp = xs
  for _c = 1, _temp.n do _result[0 + _c + _offset] = _temp[_c] end
  _offset = _offset + _temp.n
  _result.n = _offset + 0
  return _result
end
last1 = function(xs)
  if not (type1(xs) == "list") then
    error1(demandFailure1(nil, "(= (type xs) \"list\")"))
  end
  return xs[n1(xs)]
end
nth1 = function(xs, idx)
  if idx >= 0 then
    return xs[idx]
  else
    return xs[xs["n"] + 1 + idx]
  end
end
push_21_1 = function(xs, ...)
  local vals = _pack(...) vals.tag = "list"
  if not (type1(xs) == "list") then
    error1(demandFailure1(nil, "(= (type xs) \"list\")"))
  end
  local nxs = n1(xs)
  xs["n"] = (nxs + n1(vals))
  local forLimit = n1(vals)
  local i = 1
  while i <= forLimit do
    xs[nxs + i] = vals[i]
    i = i + 1
  end
  return xs
end
popLast_21_1 = function(xs)
  if not (type1(xs) == "list") then
    error1(demandFailure1(nil, "(= (type xs) \"list\")"))
  end
  local x = xs[n1(xs)]
  xs[n1(xs)] = nil
  xs["n"] = n1(xs) - 1
  return x
end
removeNth_21_1 = function(li, idx)
  if not (type1(li) == "list") then
    error1(demandFailure1(nil, "(= (type li) \"list\")"))
  end
  li["n"] = li["n"] - 1
  return remove1(li, idx)
end
insertNth_21_1 = function(li, idx, val)
  if not (type1(li) == "list") then
    error1(demandFailure1(nil, "(= (type li) \"list\")"))
  end
  li["n"] = li["n"] + 1
  return insert1(li, idx, val)
end
append1 = function(xs, ys)
  local _offset, _result, _temp = 0, {tag="list"}
  _temp = xs
  for _c = 1, _temp.n do _result[0 + _c + _offset] = _temp[_c] end
  _offset = _offset + _temp.n
  _temp = ys
  for _c = 1, _temp.n do _result[0 + _c + _offset] = _temp[_c] end
  _offset = _offset + _temp.n
  _result.n = _offset + 0
  return _result
end
reverse1 = function(xs)
  local out = {tag="list", n=0}
  local forStart = n1(xs)
  local i = forStart
  while i >= 1 do
    push_21_1(out, nth1(xs, i))
    i = i + -1
  end
  return out
end
groupsOf1 = function(xs, num)
  if not (type1(xs) == "list") then
    error1(demandFailure1(nil, "(= (type xs) \"list\")"))
  end
  local result, group = {tag="list", n=0}, nil
  local forLimit = n1(xs)
  local idx = 1
  while idx <= forLimit do
    if (idx - 1) % num == 0 then
      group = {tag="list", n=0}
      push_21_1(result, group)
    end
    push_21_1(group, nth1(xs, idx))
    idx = idx + 1
  end
  return result
end
cadr1 = function(xs)
  if not (type1(xs) == "list") then
    error1(demandFailure1(nil, "(= (type xs) \"list\")"))
  end
  return xs[2]
end
caddr1 = function(xs)
  if not (type1(xs) == "list") then
    error1(demandFailure1(nil, "(= (type xs) \"list\")"))
  end
  return xs[3]
end
cadddr1 = function(xs)
  if not (type1(xs) == "list") then
    error1(demandFailure1(nil, "(= (type xs) \"list\")"))
  end
  return xs[4]
end
charAt1 = function(xs, x)
  return sub1(xs, x, x)
end
concat2 = function(xs, separator)
  if not (type1(xs) == "list") then
    error1(demandFailure1(nil, "(= (type xs) \"list\")"))
  end
  if xs["parent"] then
    return concat1(xs["parent"], separator, xs["offset"] + 1, xs["n"] + xs["offset"])
  else
    return concat1(xs, separator, 1, xs["n"])
  end
end
split1 = function(text, pattern, limit)
  local out, loop, start = {tag="list", n=0}, true, 1
  while loop do
    local pos = list1(find1(text, pattern, start))
    local nstart, nend = car2(pos), cadr1(pos)
    if nstart == nil or limit and n1(out) >= limit then
      loop = false
      push_21_1(out, sub1(text, start, n1(text)))
      start = n1(text) + 1
    elseif nstart > #text then
      if start <= #text then
        push_21_1(out, sub1(text, start, #text))
      end
      loop = false
    elseif nend < nstart then
      push_21_1(out, sub1(text, start, nstart))
      start = nstart + 1
    else
      push_21_1(out, sub1(text, start, nstart - 1))
      start = nend + 1
    end
  end
  return out
end
trim1 = function(str)
  return (gsub1(gsub1(str, "^%s+", ""), "%s+$", ""))
end
startsWith_3f_1 = function(str, prefix)
  return sub1(str, 1, #prefix) == prefix
end
endsWith_3f_1 = function(str, suffix)
  return sub1(str, 0 - #suffix) == suffix
end
string_2d3e_chars1 = function(str)
  local len = #str
  local out = {tag="list", n=len}
  local i = 1
  while i <= len do
    out[i] = charAt1(str, i)
    i = i + 1
  end
  return out
end
execute1 = os.execute
exit1 = os.exit
getenv1 = os.getenv
remove2 = os.remove
tmpname1 = os.tmpname
close1 = io.close
flush1 = io.flush
open1 = io.open
read1 = io.read
write1 = io.write
fail_21_1 = function(x)
  return error1(x, 0)
end
exit_21_1 = function(reason, code)
  local code1
  if string_3f_1(reason) then
    code1 = code
  else
    code1 = reason
  end
  if exit1 then
    if string_3f_1(reason) then
      print1(reason)
    end
    return exit1(code1)
  elseif string_3f_1(reason) then
    return fail_21_1(reason)
  else
    return fail_21_1()
  end
end
sprintf1 = function(fmt, ...)
  local args = _pack(...) args.tag = "list"
  return apply1(format1, fmt, args)
end
printf1 = function(fmt, ...)
  local args = _pack(...) args.tag = "list"
  return print1(apply1(sprintf1, fmt, args))
end
self1 = function(x, key, ...)
  local args = _pack(...) args.tag = "list"
  return apply1(x[key], x, args)
end
gcd1 = function(x, y)
  local x1, y1 = abs1(x), abs1(y)
  while not (y1 == 0) do
    x1, y1 = y1, x1 % y1
  end
  return x1
end
succ1 = function(x)
  return x + 1
end
pred1 = function(x)
  return x - 1
end
const1 = function(x)
  return function(y)
    return x
  end
end
numerator1 = function(rational)
  return rational["numerator"]
end
denominator1 = function(rational)
  return rational["denominator"]
end
_2d3e_ratComponents1 = function(y)
  local i, f = modf1(y)
  local f_27_ = 10 ^ (n1(tostring1(f)) - 2)
  if 0 == f then
    return splice1(list1(y, 1))
  else
    local n = y * f_27_
    local g = gcd1(n, f_27_)
    return splice1(list1(n / g, (f_27_ / g)))
  end
end
normalisedRationalComponents1 = function(x)
  if number_3f_1(x) then
    return _2d3e_ratComponents1(x)
  else
    return splice1(list1(numerator1(x), (denominator1(x))))
  end
end
readAllMode_21_1 = function(path, binary)
  local handle, err = open1(path, "r" .. (function()
    if binary then
      return "b"
    else
      return ""
    end
  end)())
  if handle then
    local data = self1(handle, "read", "*a")
    self1(handle, "close")
    return data
  else
    return splice1(list1(handle, err))
  end
end
readLines_21_1 = function(path)
  local data, err = readAllMode_21_1(path, true)
  if data then
    return split1(data, "\n")
  else
    return splice1(list1(nil, err))
  end
end
writeAllMode_21_1 = function(path, append, binary, data)
  local handle = open1(path, (function()
    if append then
      return "a"
    else
      return "w"
    end
  end)() .. (function()
    if binary then
      return "b"
    else
      return ""
    end
  end)())
  if handle then
    self1(handle, "write", data)
    self1(handle, "close")
    return true
  else
    return false
  end
end
writeAll_21_1 = function(path, data)
  return writeAllMode_21_1(path, false, false, data)
end
writeLines_21_1 = function(path, data)
  return writeAll_21_1(path, concat2(data, "\n"))
end
appendAll_21_1 = function(path, data)
  return writeAllMode_21_1(path, true, false, data)
end
fileExists_3f_1 = function(path)
  local _5f_chid = open1(path)
  if _enot1(_5f_chid) then
    return false
  else
    close1(_5f_chid)
    return true
  end
end
OS_3f_1 = function()
  local _5f_temp_5f_file, _5f_os = tmpname1(), nil
  remove2(_5f_temp_5f_file)
  if startsWith_3f_1(_5f_temp_5f_file, "T:") then
    _5f_os = "AmigaOS"
  elseif startsWith_3f_1(_5f_temp_5f_file, "/") then
    _5f_os = "UNIX"
  elseif eq_3f_1(charAt1(_5f_temp_5f_file, 2), ":") then
    _5f_os = "Ms Windows"
  else
    _5f_os = "Unknown"
  end
  return _5f_os
end
scroll1 = function(_5f_list, _5f_start, _5f_step, _5f_line_5f_number)
  local _5f_got_5f_input, _5f_current_5f_page, _5f_total_5f_pages = nil, ceil1(_5f_start / _5f_step), ceil1(n1(_5f_list) / _5f_step)
  _5f_list = drop1(_5f_list, _5f_start - 1)
  if _enot1(_5f_line_5f_number) then
    local temp = groupsOf1(_5f_list, _5f_step)
    local forLimit = n1(temp)
    local i = 1
    while i <= forLimit do
      local _5f_list1 = temp[i]
      if neq_3f_1(_5f_got_5f_input, "s") then
        local forLimit1 = n1(_5f_list1)
        local i1 = 1
        while i1 <= forLimit1 do
          print1((_5f_list1[i1]))
          _5f_start = succ1(_5f_start)
          i1 = i1 + 1
        end
        write1(sprintf1("< %d / %d >", _5f_current_5f_page, _5f_total_5f_pages))
        flush1()
        _5f_got_5f_input = read1()
        _5f_current_5f_page = succ1(_5f_current_5f_page)
      end
      i = i + 1
    end
  else
    local temp = groupsOf1(_5f_list, _5f_step)
    local forLimit = n1(temp)
    local i = 1
    while i <= forLimit do
      local _5f_list1 = temp[i]
      if neq_3f_1(_5f_got_5f_input, "s") then
        local forLimit1 = n1(_5f_list1)
        local i1 = 1
        while i1 <= forLimit1 do
          local _5f_string = _5f_list1[i1]
          printf1("%d\9%s", _5f_start, _5f_string)
          _5f_start = succ1(_5f_start)
          i1 = i1 + 1
        end
        write1(sprintf1("< %d / %d >", _5f_current_5f_page, _5f_total_5f_pages))
        flush1()
        _5f_got_5f_input = read1()
        _5f_current_5f_page = succ1(_5f_current_5f_page)
      end
      i = i + 1
    end
  end
  return list1(_5f_start, _5f_step, _5f_line_5f_number)
end
if n1(_2a_arguments_2a_1) == 0 then
  exit_21_1("Please specify a file name.", 3)
end
local _5f_file_5f_name = car2(_2a_arguments_2a_1)
local _5f_buffer, _5f_OS, _5f_got_5f_list, _5f_copied, _5f_from, _5f_to, _5f_to_5f_insert, _5f_record_5f_scroll = readLines_21_1(_5f_file_5f_name), OS_3f_1(), {tag="list", n=0}, {tag="list", n=0}, 0, 0, nil, {tag="list", n=2, 1, 40}
local _5f_old_5f_buffer, _5f_shell_5f_command = _5f_buffer, ""
if _enot1(_5f_buffer) then
  print1("New file.")
  _5f_buffer = {tag="list", n=0}
else
  print1("File open successful.")
end
if eq_3f_1(_5f_OS, "UNIX") and (eq_3f_1(getenv1("TERM"), "xterm") and execute1("which xsel >/dev/null") == 0) then
  _5f_OS = "UNIX+XTerm&XSel"
end
while true do
  write1("led>")
  flush1()
  local _5f_got_5f_input = read1()
  if _5f_got_5f_input then
    _5f_got_5f_list = split1(_5f_got_5f_input, ",")
    local forLimit = n1(_5f_got_5f_list)
    local _5f_index = 1
    while _5f_index <= forLimit do
      if match1(nth1(_5f_got_5f_list, _5f_index), "|cM") then
        local val = _5f_got_5f_list
        if _5f_index >= 0 then
          val[_5f_index] = const1(gsub1(nth1(_5f_got_5f_list, _5f_index), "|cM", ","))(val[_5f_index])
        else
          local idx = val["n"] + 1 + _5f_index
          val[idx] = const1(gsub1(nth1(_5f_got_5f_list, _5f_index), "|cM", ","))(val[idx])
        end
      end
      _5f_index = _5f_index + 1
    end
    if eq_3f_1(car2(_5f_got_5f_list), "1") then
      if n1(_5f_got_5f_list) == 1 or tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) then
        local _5f_max_5f_lines = 10
        if _5f_max_5f_lines > n1(_5f_buffer) then
          _5f_max_5f_lines = n1(_5f_buffer)
        end
        if n1(_5f_got_5f_list) >= 2 then
          _5f_max_5f_lines = tonumber1(cadr1(_5f_got_5f_list))
        end
        if n1(_5f_got_5f_list) == 3 then
          local forLimit = _5f_max_5f_lines
          local _5f_line = 1
          while _5f_line <= forLimit do
            printf1("%d\9%s", _5f_line, nth1(_5f_buffer, _5f_line))
            _5f_line = _5f_line + 1
          end
        else
          local forLimit = _5f_max_5f_lines
          local _5f_line = 1
          while _5f_line <= forLimit do
            print1(nth1(_5f_buffer, _5f_line))
            _5f_line = _5f_line + 1
          end
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "a") or eq_3f_1(car2(_5f_got_5f_list), "z") then
      if tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) then
        local _5f_selected_5f_line, _5f_half, _5f_start, _5f_end = tonumber1(cadr1(_5f_got_5f_list)), 5, 1, n1(_5f_buffer)
        if tonumber1(caddr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(caddr1(_5f_got_5f_list))) then
          _5f_half = tonumber1(caddr1(_5f_got_5f_list))
        end
        if nth1(_5f_buffer, _5f_selected_5f_line - _5f_half) then
          _5f_start = _5f_selected_5f_line - _5f_half
        end
        if nth1(_5f_buffer, _5f_selected_5f_line + _5f_half) then
          _5f_end = _5f_selected_5f_line + _5f_half
        end
        if eq_3f_1(car2(_5f_got_5f_list), "a") then
          local forStart, forLimit = _5f_start, _5f_end
          local _5f_line = forStart
          while _5f_line <= forLimit do
            printf1("%d\9%s", _5f_line, nth1(_5f_buffer, _5f_line))
            _5f_line = _5f_line + 1
          end
        else
          local forStart, forLimit = _5f_start, _5f_end
          local _5f_line = forStart
          while _5f_line <= forLimit do
            print1(nth1(_5f_buffer, _5f_line))
            _5f_line = _5f_line + 1
          end
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "b") then
      if n1(_5f_got_5f_list) == 1 or tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) then
        local _5f_max_5f_lines = 10
        if _5f_max_5f_lines > n1(_5f_buffer) then
          _5f_max_5f_lines = n1(_5f_buffer)
        end
        if n1(_5f_got_5f_list) >= 2 then
          _5f_max_5f_lines = tonumber1(cadr1(_5f_got_5f_list))
        end
        _5f_max_5f_lines = pred1(_5f_max_5f_lines)
        if n1(_5f_got_5f_list) == 3 then
          local forStart, forLimit = n1(_5f_buffer) - _5f_max_5f_lines, n1(_5f_buffer)
          local _5f_line = forStart
          while _5f_line <= forLimit do
            printf1("%d\9%s", _5f_line, nth1(_5f_buffer, _5f_line))
            _5f_line = _5f_line + 1
          end
        else
          local forStart, forLimit = n1(_5f_buffer) - _5f_max_5f_lines, n1(_5f_buffer)
          local _5f_line = forStart
          while _5f_line <= forLimit do
            print1(nth1(_5f_buffer, _5f_line))
            _5f_line = _5f_line + 1
          end
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "c") then
      _5f_copied = {tag="list", n=0}
      if n1(_5f_got_5f_list) == 1 then
        _5f_copied = _5f_buffer
      elseif n1(_5f_got_5f_list) == 2 and (tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))) then
        _5f_copied = list1(nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))))
      elseif n1(_5f_got_5f_list) == 3 and (tonumber1(cadr1(_5f_got_5f_list)) and tonumber1(caddr1(_5f_got_5f_list))) then
        if nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) and nth1(_5f_buffer, tonumber1(caddr1(_5f_got_5f_list))) then
          local forStart, forLimit = tonumber1(cadr1(_5f_got_5f_list)), tonumber1(caddr1(_5f_got_5f_list))
          local _5f_line = forStart
          while _5f_line <= forLimit do
            _5f_copied = snoc1(_5f_copied, nth1(_5f_buffer, _5f_line))
            _5f_line = _5f_line + 1
          end
        end
      end
      if eq_3f_1(_5f_OS, "UNIX+XTerm&XSel") then
        local _5f_temp_5f_file = tmpname1()
        appendAll_21_1(_5f_temp_5f_file, concat2(_5f_copied, "\n"))
        execute1(sprintf1("xsel -cb && xsel -bl /tmp/.xsel.log <%s 2>/dev/null", _5f_temp_5f_file))
        remove2(_5f_temp_5f_file)
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "d") then
      if n1(_5f_got_5f_list) == 1 then
        _5f_old_5f_buffer = _5f_buffer
        _5f_buffer = {tag="list", n=0}
      elseif n1(_5f_got_5f_list) == 2 and (tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))) then
        _5f_old_5f_buffer = snoc1(_5f_buffer)
        removeNth_21_1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))
      elseif n1(_5f_got_5f_list) == 3 and (tonumber1(cadr1(_5f_got_5f_list)) and tonumber1(caddr1(_5f_got_5f_list))) then
        if nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) and nth1(_5f_buffer, tonumber1(caddr1(_5f_got_5f_list))) then
          _5f_old_5f_buffer = snoc1(_5f_buffer)
          local forStart, forLimit = tonumber1(cadr1(_5f_got_5f_list)), tonumber1(caddr1(_5f_got_5f_list))
          local _5f_line = forStart
          while _5f_line <= forLimit do
            removeNth_21_1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))
            _5f_line = _5f_line + 1
          end
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "e") then
      if tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) then
        _5f_old_5f_buffer = snoc1(_5f_buffer)
        if eq_3f_1(_5f_OS, "AmigaOS") then
          local _5f_old_5f_string, _5f_new_5f_string = nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))), ""
          local temp = string_2d3e_chars1(_5f_old_5f_string)
          local forLimit = n1(temp)
          local i = 1
          while i <= forLimit do
            local _5f_char = temp[i]
            if match1(_5f_char, "%a") then
              _5f_new_5f_string = sprintf1("%s%s", _5f_new_5f_string, _5f_char)
            else
              _5f_new_5f_string = sprintf1("%s*%s", _5f_new_5f_string, _5f_char)
            end
            i = i + 1
          end
          execute1(sprintf1("C:Run >NIL: C:Clip set \"%s\"", _5f_new_5f_string))
        elseif eq_3f_1(_5f_OS, "UNIX+XTerm&XSel") then
          local _5f_temp_5f_file = tmpname1()
          appendAll_21_1(_5f_temp_5f_file, nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))))
          execute1(sprintf1("xsel -c && xsel -l /tmp/.xsel.log <%s 2>/dev/null", _5f_temp_5f_file))
          remove2(_5f_temp_5f_file)
        else
          local _5f_selected_5f_line = nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))
          if _5f_selected_5f_line then
            printf1("-\n%s\n+", _5f_selected_5f_line)
          else
            print1("-\n+")
          end
        end
        if n1(_5f_got_5f_list) == 2 then
          local val, idx = _5f_buffer, tonumber1(cadr1(_5f_got_5f_list))
          if idx >= 0 then
            val[idx] = const1(read1())(val[idx])
          else
            local idx1 = val["n"] + 1 + idx
            val[idx1] = const1(read1())(val[idx1])
          end
        else
          removeNth_21_1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))
          _5f_to_5f_insert = {tag="list", n=0}
          while neq_3f_1(last1(_5f_to_5f_insert), ".") do
            _5f_to_5f_insert = snoc1(_5f_to_5f_insert, read1())
          end
          popLast_21_1(_5f_to_5f_insert)
          local temp = reverse1(_5f_to_5f_insert)
          local forLimit = n1(temp)
          local i = 1
          while i <= forLimit do
            local _5f_string = temp[i]
            insertNth_21_1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)), _5f_string)
            i = i + 1
          end
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "f") then
      if n1(_5f_got_5f_list) == 1 then
        if empty_3f_1(_5f_buffer) then
          printf1("Name: %s  Lines: 0  Bytes: 0  Format:", _5f_file_5f_name)
        else
          local _5f_bytes, _5f_format = n1(_5f_buffer), "Unix"
          local temp = _5f_buffer
          local forLimit = n1(temp)
          local i = 1
          while i <= forLimit do
            local _5f_string = temp[i]
            _5f_bytes = _5f_bytes + len1(_5f_string)
            i = i + 1
          end
          _5f_bytes = pred1(_5f_bytes)
          if endsWith_3f_1(car2(_5f_buffer), "\13") then
            _5f_format = "DOS/Mac"
          end
          printf1("Name: %s  Lines: %d  Bytes: %d  Format: %s", _5f_file_5f_name, n1(_5f_buffer), _5f_bytes, _5f_format)
        end
      elseif fileExists_3f_1(trim1(cadr1(_5f_got_5f_list))) then
        write1("This file exists, do you want to proceed? <y/N>")
        flush1()
        if eq_3f_1(read1(), "y") then
          _5f_file_5f_name = trim1(cadr1(_5f_got_5f_list))
        end
      else
        _5f_file_5f_name = trim1(cadr1(_5f_got_5f_list))
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "g") then
      if n1(_5f_got_5f_list) == 1 then
        local forStart, forLimit = _5f_from, _5f_to
        local _5f_line = forStart
        while _5f_line <= forLimit do
          local _5f_string = nth1(_5f_buffer, _5f_line)
          if _5f_string then
            printf1("%d\9%s", _5f_line, _5f_string)
          end
          _5f_line = _5f_line + 1
        end
      elseif tonumber1(cadr1(_5f_got_5f_list)) and (tonumber1(caddr1(_5f_got_5f_list)) and tonumber1(caddr1(_5f_got_5f_list)) > tonumber1(cadr1(_5f_got_5f_list))) then
        if nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) and nth1(_5f_buffer, tonumber1(caddr1(_5f_got_5f_list))) then
          _5f_from = tonumber1(cadr1(_5f_got_5f_list))
          _5f_to = tonumber1(caddr1(_5f_got_5f_list))
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "h") then
      local _5f_help = {tag="list", n=26, "Usage: lua led.lua FILE\n", "Commands are:", "  1[,#,n]     List the 1st lines (default 10), with n show line number", "  a|z,#[,#]   List the previous and following lines (default 5) of any line, with (a) or without (z) line number", "  b[,#,n]     List the bottom lines (default 10), with n show line number", "  c[,#,#]     Copy all or some or only one line", "  d[,#,#]     Delete all or some or only one line", "  e,#[,i]     Edit a line (get it from clipboard), with i start to insert below that line, type a dot to exit", "  f[,$]       Show file infos or change file name", "  g[,#,#]     Mark a range of lines, list that range with line number", "  h[,#]       Show this help (default all)", "  i[,#]       Insert into buffer given text below last or from any line, type a dot to exit", "  j,#,#       Join a line with another", "  k           List marked range without line number", "  l|n[,#,#]   List all or some or only one line, without (l) or with (n) line number", "  m[,#,n]     Press Return to scroll # lines every time (default 40), with n show line number, type s to stop, 'm,' to continue", "  o           Switch to DOS/Mac format", "  p[,#]       Paste below last or from any line", "  q           Ask to quit", "  r,$         Read a file and append content into buffer", "  s,$[,$,#,#] Search a string or substitute it with another one (support Lua patterns) in all or some or only one line, for a comma type |cM", "  t[,#]       Replace tab with # spaces (default 1)", "  u           Undo<->Redo", "  v           Show version and license", "  w           Write out", "  x[,$,r]     Write and execute file or a shell command + file, execute a shell command, with r record it"}
      local _5f_show = n1(_5f_help)
      if n1(_5f_got_5f_list) == 2 and (tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_help, tonumber1(cadr1(_5f_got_5f_list)))) then
        _5f_show = tonumber1(cadr1(_5f_got_5f_list))
      end
      local forLimit = _5f_show
      local _5f_index = 1
      while _5f_index <= forLimit do
        print1(nth1(_5f_help, _5f_index))
        _5f_index = _5f_index + 1
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "i") then
      _5f_to_5f_insert = {tag="list", n=0}
      if n1(_5f_got_5f_list) == 1 then
        local _5f_string = last1(_5f_buffer)
        if _5f_string then
          printf1("%s", _5f_string)
        end
      elseif tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) then
        local _5f_string = nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)) - 1)
        if _5f_string then
          printf1("%s", _5f_string)
        end
      end
      while neq_3f_1(last1(_5f_to_5f_insert), ".") do
        _5f_to_5f_insert = snoc1(_5f_to_5f_insert, read1())
      end
      popLast_21_1(_5f_to_5f_insert)
      if n1(_5f_got_5f_list) == 1 then
        _5f_old_5f_buffer = _5f_buffer
        _5f_buffer = append1(_5f_buffer, _5f_to_5f_insert)
      elseif tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) then
        _5f_old_5f_buffer = snoc1(_5f_buffer)
        local temp = reverse1(_5f_to_5f_insert)
        local forLimit = n1(temp)
        local i = 1
        while i <= forLimit do
          local _5f_string = temp[i]
          insertNth_21_1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)), _5f_string)
          i = i + 1
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "j") then
      if n1(_5f_got_5f_list) == 3 and (tonumber1(cadr1(_5f_got_5f_list)) and tonumber1(caddr1(_5f_got_5f_list))) then
        if nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) and nth1(_5f_buffer, tonumber1(caddr1(_5f_got_5f_list))) then
          _5f_old_5f_buffer = snoc1(_5f_buffer)
          local val, idx = _5f_buffer, tonumber1(cadr1(_5f_got_5f_list))
          if idx >= 0 then
            val[idx] = const1(sprintf1("%s%s", nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))), nth1(_5f_buffer, tonumber1(caddr1(_5f_got_5f_list)))))(val[idx])
          else
            local idx1 = val["n"] + 1 + idx
            val[idx1] = const1(sprintf1("%s%s", nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))), nth1(_5f_buffer, tonumber1(caddr1(_5f_got_5f_list)))))(val[idx1])
          end
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "k") then
      local forStart, forLimit = _5f_from, _5f_to
      local _5f_line = forStart
      while _5f_line <= forLimit do
        local _5f_string = nth1(_5f_buffer, _5f_line)
        if _5f_string then
          printf1("%s", _5f_string)
        end
        _5f_line = _5f_line + 1
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "l") then
      if n1(_5f_got_5f_list) == 1 then
        local forLimit = n1(_5f_buffer)
        local _5f_line = 1
        while _5f_line <= forLimit do
          print1(nth1(_5f_buffer, _5f_line))
          _5f_line = _5f_line + 1
        end
      elseif n1(_5f_got_5f_list) == 2 and (tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))) then
        print1(nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))))
      elseif n1(_5f_got_5f_list) == 3 and (tonumber1(cadr1(_5f_got_5f_list)) and tonumber1(caddr1(_5f_got_5f_list))) then
        if nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) and nth1(_5f_buffer, tonumber1(caddr1(_5f_got_5f_list))) then
          local forStart, forLimit = tonumber1(cadr1(_5f_got_5f_list)), tonumber1(caddr1(_5f_got_5f_list))
          local _5f_line = forStart
          while _5f_line <= forLimit do
            print1(nth1(_5f_buffer, _5f_line))
            _5f_line = _5f_line + 1
          end
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "m") then
      if n1(_5f_got_5f_list) == 1 then
        _5f_record_5f_scroll = scroll1(_5f_buffer, 1, 40, false)
      elseif n1(_5f_got_5f_list) == 2 and (tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))) then
        _5f_record_5f_scroll = scroll1(_5f_buffer, 1, tonumber1(cadr1(_5f_got_5f_list)), false)
      elseif n1(_5f_got_5f_list) == 3 and (tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))) then
        _5f_record_5f_scroll = scroll1(_5f_buffer, 1, tonumber1(cadr1(_5f_got_5f_list)), true)
      else
        _5f_record_5f_scroll = scroll1(_5f_buffer, car2(_5f_record_5f_scroll), cadr1(_5f_record_5f_scroll), caddr1(_5f_record_5f_scroll))
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "n") then
      if n1(_5f_got_5f_list) == 1 then
        local forLimit = n1(_5f_buffer)
        local _5f_line = 1
        while _5f_line <= forLimit do
          printf1("%d\9%s", _5f_line, nth1(_5f_buffer, _5f_line))
          _5f_line = _5f_line + 1
        end
      elseif n1(_5f_got_5f_list) == 2 and (tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)))) then
        printf1("%d\9%s", tonumber1(cadr1(_5f_got_5f_list)), nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))))
      elseif n1(_5f_got_5f_list) == 3 and (tonumber1(cadr1(_5f_got_5f_list)) and tonumber1(caddr1(_5f_got_5f_list))) then
        if nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) and nth1(_5f_buffer, tonumber1(caddr1(_5f_got_5f_list))) then
          local forStart, forLimit = tonumber1(cadr1(_5f_got_5f_list)), tonumber1(caddr1(_5f_got_5f_list))
          local _5f_line = forStart
          while _5f_line <= forLimit do
            printf1("%d\9%s", _5f_line, nth1(_5f_buffer, _5f_line))
            _5f_line = _5f_line + 1
          end
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "o") then
      _5f_old_5f_buffer = _5f_buffer
      _5f_buffer = {tag="list", n=0}
      local temp = _5f_old_5f_buffer
      local forLimit = n1(temp)
      local i = 1
      while i <= forLimit do
        local _5f_string = temp[i]
        if endsWith_3f_1(_5f_string, "\13") then
          push_21_1(_5f_buffer, _5f_string)
        else
          push_21_1(_5f_buffer, sprintf1("%s\13", _5f_string))
        end
        i = i + 1
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "p") then
      if n1(_5f_got_5f_list) == 1 then
        _5f_old_5f_buffer = _5f_buffer
        _5f_buffer = append1(_5f_buffer, _5f_copied)
      elseif tonumber1(cadr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list))) then
        _5f_old_5f_buffer = snoc1(_5f_buffer)
        local temp = reverse1(_5f_copied)
        local forLimit = n1(temp)
        local i = 1
        while i <= forLimit do
          local _5f_string = temp[i]
          insertNth_21_1(_5f_buffer, tonumber1(cadr1(_5f_got_5f_list)), _5f_string)
          i = i + 1
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "q") then
      write1("Do you really want to quit now? <y/N>")
      flush1()
      if eq_3f_1(read1(), "y") then
        exit_21_1()
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "r") then
      if n1(_5f_got_5f_list) == 2 and _enot1(empty_3f_1(trim1(cadr1(_5f_got_5f_list)))) then
        if fileExists_3f_1(trim1(cadr1(_5f_got_5f_list))) then
          _5f_old_5f_buffer = _5f_buffer
          _5f_buffer = append1(_5f_buffer, readLines_21_1(trim1(cadr1(_5f_got_5f_list))))
          print1("File read successful.")
        else
          print1("File read failed.")
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "s") then
      if n1(_5f_got_5f_list) == 2 then
        local _5f_pattern, _5f_total_5f_found = cadr1(_5f_got_5f_list), 0
        local forLimit = n1(_5f_buffer)
        local _5f_line = 1
        while _5f_line <= forLimit do
          local _5f_string = nth1(_5f_buffer, _5f_line)
          if pcall1(match1, _5f_string, _5f_pattern) and match1(_5f_string, _5f_pattern) then
            printf1("%d\9%s", _5f_line, nth1(_5f_buffer, _5f_line))
            _5f_total_5f_found = _5f_total_5f_found + cadr1(list1(gsub1(_5f_string, _5f_pattern, "")))
          end
          _5f_line = _5f_line + 1
        end
        printf1("Total found: %d", _5f_total_5f_found)
      elseif n1(_5f_got_5f_list) == 3 then
        _5f_old_5f_buffer = snoc1(_5f_buffer)
        local forLimit = n1(_5f_buffer)
        local _5f_line = 1
        while _5f_line <= forLimit do
          if pcall1(match1, nth1(_5f_buffer, _5f_line), cadr1(_5f_got_5f_list)) and match1(nth1(_5f_buffer, _5f_line), cadr1(_5f_got_5f_list)) then
            local val = _5f_buffer
            if _5f_line >= 0 then
              val[_5f_line] = const1(gsub1(nth1(_5f_buffer, _5f_line), cadr1(_5f_got_5f_list), caddr1(_5f_got_5f_list)))(val[_5f_line])
            else
              local idx = val["n"] + 1 + _5f_line
              val[idx] = const1(gsub1(nth1(_5f_buffer, _5f_line), cadr1(_5f_got_5f_list), caddr1(_5f_got_5f_list)))(val[idx])
            end
          end
          _5f_line = _5f_line + 1
        end
      elseif n1(_5f_got_5f_list) == 4 then
        if tonumber1(cadddr1(_5f_got_5f_list)) and nth1(_5f_buffer, tonumber1(cadddr1(_5f_got_5f_list))) then
          if pcall1(match1, nth1(_5f_buffer, tonumber1(cadddr1(_5f_got_5f_list))), cadr1(_5f_got_5f_list)) and match1(nth1(_5f_buffer, tonumber1(cadddr1(_5f_got_5f_list))), cadr1(_5f_got_5f_list)) then
            _5f_old_5f_buffer = snoc1(_5f_buffer)
            local val, idx = _5f_buffer, tonumber1(cadddr1(_5f_got_5f_list))
            if idx >= 0 then
              val[idx] = const1(gsub1(nth1(_5f_buffer, tonumber1(cadddr1(_5f_got_5f_list))), cadr1(_5f_got_5f_list), caddr1(_5f_got_5f_list)))(val[idx])
            else
              local idx1 = val["n"] + 1 + idx
              val[idx1] = const1(gsub1(nth1(_5f_buffer, tonumber1(cadddr1(_5f_got_5f_list))), cadr1(_5f_got_5f_list), caddr1(_5f_got_5f_list)))(val[idx1])
            end
          end
        end
      elseif n1(_5f_got_5f_list) == 5 then
        if tonumber1(cadddr1(_5f_got_5f_list)) and tonumber1(last1(_5f_got_5f_list)) then
          if nth1(_5f_buffer, tonumber1(cadddr1(_5f_got_5f_list))) and nth1(_5f_buffer, tonumber1(last1(_5f_got_5f_list))) then
            _5f_old_5f_buffer = snoc1(_5f_buffer)
            local forStart, forLimit = tonumber1(cadddr1(_5f_got_5f_list)), tonumber1(last1(_5f_got_5f_list))
            local _5f_line = forStart
            while _5f_line <= forLimit do
              if pcall1(match1, nth1(_5f_buffer, _5f_line), cadr1(_5f_got_5f_list)) and match1(nth1(_5f_buffer, _5f_line), cadr1(_5f_got_5f_list)) then
                local val = _5f_buffer
                if _5f_line >= 0 then
                  val[_5f_line] = const1(gsub1(nth1(_5f_buffer, _5f_line), cadr1(_5f_got_5f_list), caddr1(_5f_got_5f_list)))(val[_5f_line])
                else
                  local idx = val["n"] + 1 + _5f_line
                  val[idx] = const1(gsub1(nth1(_5f_buffer, _5f_line), cadr1(_5f_got_5f_list), caddr1(_5f_got_5f_list)))(val[idx])
                end
              end
              _5f_line = _5f_line + 1
            end
          end
        end
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "v") then
      print1("led version 20200101\n\nCopyright (c) 2020, Pasquale Frega\n\nAll rights reserved.\n\nReleased under the simplified BSD license.")
    elseif eq_3f_1(car2(_5f_got_5f_list), "t") then
      _5f_old_5f_buffer = _5f_buffer
      _5f_buffer = {tag="list", n=0}
      local _5f_times, _5f_spaces = tonumber1(cadr1(_5f_got_5f_list)), nil
      if _enot1(_5f_times) then
        _5f_times = 1
      end
      _5f_spaces = rep1(" ", _5f_times)
      local temp = _5f_old_5f_buffer
      local forLimit = n1(temp)
      local i = 1
      while i <= forLimit do
        local _5f_string = temp[i]
        push_21_1(_5f_buffer, car2(list1(gsub1(_5f_string, "\9", _5f_spaces))))
        i = i + 1
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "u") then
      local _5f_exchanger = _5f_buffer
      _5f_buffer = _5f_old_5f_buffer
      _5f_old_5f_buffer = _5f_exchanger
    elseif eq_3f_1(car2(_5f_got_5f_list), "w") then
      if writeLines_21_1(_5f_file_5f_name, _5f_buffer) then
        print1("File written.")
      else
        print1("Unable to write file.")
      end
    elseif eq_3f_1(car2(_5f_got_5f_list), "x") then
      if n1(_5f_got_5f_list) == 1 then
        if writeLines_21_1(_5f_file_5f_name, _5f_buffer) then
          execute1(trim1(sprintf1("%s %s", _5f_shell_5f_command, _5f_file_5f_name)))
        else
          print1("Unable to write file.")
        end
      elseif n1(_5f_got_5f_list) == 2 and _enot1(empty_3f_1(trim1(cadr1(_5f_got_5f_list)))) then
        execute1(trim1(cadr1(_5f_got_5f_list)))
      else
        _5f_shell_5f_command = trim1(cadr1(_5f_got_5f_list))
      end
    end
  end
end
